Index: translate.c
===================================================================
RCS file: /usr/cvsroot/asterisk/translate.c,v
retrieving revision 1.19
diff -u -r1.19 translate.c
--- translate.c	20 Mar 2004 10:55:57 -0000	1.19
+++ translate.c	3 Apr 2004 03:26:34 -0000
@@ -54,6 +54,7 @@
 struct ast_trans_pvt {
 	struct ast_translator *step;
 	struct ast_translator_pvt *state;
+	int hold;
 	struct ast_trans_pvt *next;
 };
 
@@ -124,6 +125,9 @@
 			return NULL;
 		}
 	}
+	if (tmpr) {
+		tmpr->hold = 0;
+	}
 	return tmpr;
 }
 
@@ -133,10 +137,19 @@
 	struct ast_frame *out;
 	struct timeval delivery;
 	p = path;
-	/* Feed the first frame into the first translator */
-	p->step->framein(p->state, f);
 	delivery.tv_sec = f->delivery.tv_sec;
 	delivery.tv_usec = f->delivery.tv_usec;
+	if(delivery.tv_sec || delivery.tv_usec) {
+		delivery.tv_sec -= hold / 8000;
+		delivery.tv_usec -= (hold % 8000) * 125;
+		if(delivery.tv_usec < 0) {
+			delivery.tv_usec += 1000000;
+			delivery.tv_sec -= 1;
+		}
+	}
+	path->hold += f->samples;
+	/* Feed the first frame into the first translator */
+	p->step->framein(p->state, f);
 	if (consume)
 		ast_frfree(f);
 	while(p) {
@@ -151,6 +164,7 @@
 		else {
 			out->delivery.tv_sec = delivery.tv_sec;
 			out->delivery.tv_usec = delivery.tv_usec;
+			path->hold -= out->samples;
 			return out;
 		}
 		p = p->next;
